--
-- Mod: Animal Worker
--
-- Author: Tunnelrat
-- @Date: 06.19.2019
-- @Version: 0.0.0.1 -- beta
-- @Version: 1.0.0.0 Animal worker automatically fills your water troughs.
-- Copyright (C) Tunnelrat, All Rights Reserved.

animalWorker = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml")


animalWorker.version = getXMLString(modDesc, "modDesc.version")
animalWorker.modDirectory = g_currentModDirectory

addModEventListener(animalWorker)

function animalWorker:loadMap()

print("############################################################")
print("--- Animal Worker v.:" .. self.version .. ", by Tunnelrat.")
print("############################################################")

end

function animalWorker:keyEvent(unicode, sym, modifier, isDown)

end

function animalWorker:mouseEvent(posX, posY, isDown, isUp, button)
end


function animalWorker:deleteMap()
end

function animalWorker:update(dt)

	local hourNow = g_currentMission.environment.currentHour
	local minuteNow = g_currentMission.environment.currentMinute
	
	-- Fill water troughs and straw at 7am
	if hourNow == 7 then
		
		-- Pay the worker...
		local fee = 0.05
		local difficultyMultiplier = g_currentMission.missionInfo.buyPriceMultiplier
		local price = 500 * difficultyMultiplier * fee
		if minuteNow == 00 then
			g_currentMission:addMoney(-price, 1, MoneyType.AI, true)
			local text = "- $" .. price .. "Animal Worker (AI)"
			local color = {255, 255, 255, 0}
			local displayDuration = 5000
			SideNotification:addNotification(text, color, displayDuration)
		end
		-- End costs
	
		for k,husbandry in pairs(g_currentMission.husbandries) do
			
			-- Water
			if husbandry.modulesByName.water ~= nil then
				local amountToAdd = husbandry.modulesByName.water:getFreeCapacity(FillType.WATER)
				local fillLevel, capacity = 0, 0
    
				fillLevel = husbandry.modulesByName.water:getFillLevel(FillType.WATER)
				capacity = husbandry.modulesByName.water.fillCapacity
		
				if amountToAdd > 0 then
					husbandry.modulesByName.water:setFillLevel(FillType.WATER, capacity)					
				end
			end
			
			-- Straw
			if husbandry.modulesByName.straw ~= nil then
				local amountToAdd = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
				local fillLevel, capacity = 0, 0
    
				fillLevel = husbandry.modulesByName.straw:getFillLevel(FillType.STRAW)
				capacity = husbandry.modulesByName.straw.fillCapacity
		
				if amountToAdd > 0 then
					husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, capacity)
				end
			end
		
		end
		print("animalWorker:Ranch hand refilled water and straw for all your animals at 9pm.")
	end
end

function animalWorker:draw()
end